/*
 * Fachlicher Schlüssel für JPA Entität
 */
package de.ivu.elect.business.statistik.entity;

import de.ivu.elect.jee.faces.Messages;
import java.util.function.Function;

@javax.enterprise.inject.Vetoed
public class StatistikLaufTK
implements de.ivu.elect.jee.entity.tk.EntityTK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

  private final int hashCode;

    protected final java.lang.String ausloeser;
    public java.lang.String getAusloeser(){
      return ausloeser;
    }
    protected final java.util.Date zeitpunktDesLaufs;
    public java.util.Date getZeitpunktDesLaufs(){
      return zeitpunktDesLaufs;
    }
  protected final de.ivu.elect.business.wahl.entity.WahlTK wahlTK;
    public de.ivu.elect.business.wahl.entity.WahlTK getWahlTK(){
      return wahlTK;
    }
  protected final de.ivu.elect.business.wahl.entity.WahlterminTK wahlterminTK;
    public de.ivu.elect.business.wahl.entity.WahlterminTK getWahlterminTK(){
      return wahlterminTK;
    }

  public StatistikLaufTK(
java.lang.String ausloeser
, java.util.Date zeitpunktDesLaufs
,   de.ivu.elect.business.wahl.entity.WahlTK wahlTK
,   de.ivu.elect.business.wahl.entity.WahlterminTK wahlterminTK
  ) {
    super();


      this.ausloeser = ausloeser;
      this.zeitpunktDesLaufs = zeitpunktDesLaufs;
        this.wahlTK = wahlTK;
      this.wahlterminTK = wahlterminTK;
  
hashCode = calculateHashCode();
  }

  @Override
  public int hashCode(){
    return hashCode;
  }


  protected int calculateHashCode() {
        int result = 1;
    
    
                    result = result + ((ausloeser == null) ? 0 : ausloeser.hashCode());
                    result = result + ((zeitpunktDesLaufs == null) ? 0 : zeitpunktDesLaufs.hashCode());
        
                    result = result + ((wahlTK == null) ? 0 : wahlTK.hashCode());
                    result = result + ((wahlterminTK == null) ? 0 : wahlterminTK.hashCode());
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    if (hashCode()!=obj.hashCode()) {
      return false;
    }


            
    if (getClass() != obj.getClass()) {
      if (!(obj instanceof StatistikLaufTK)) {
        return false;
      }

      if (!obj.getClass().isInstance(this)) {
        return obj.equals(this); // equals-Methode aus speziellerer Klasse verwenden
      }

    }

        StatistikLaufTK other = (StatistikLaufTK) obj;

                if (ausloeser == null) {
          if (other.ausloeser != null) {
            return false;
          }
        } else if (!ausloeser.equals(other.ausloeser)) {
          return false;
        }
                if (zeitpunktDesLaufs == null) {
          if (other.zeitpunktDesLaufs != null) {
            return false;
          }
        } else if (!zeitpunktDesLaufs.equals(other.zeitpunktDesLaufs)) {
          return false;
        }
        
                if (wahlTK == null) {
          if (other.wahlTK != null) {
            return false;
          }
        } else if (!wahlTK.equals(other.wahlTK)) {
          return false;
        }
                if (wahlterminTK == null) {
          if (other.wahlterminTK != null) {
            return false;
          }
        } else if (!wahlterminTK.equals(other.wahlterminTK)) {
          return false;
        }
            return true;
    
  }

  protected boolean hatAttribute() {
        return true;
      }

  @Override
  public String getEntityMessageKey() {
    return StatistikLaufConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    result.addAll(wahlTK.getAllEntityFieldValues());
    result.addAll(wahlterminTK.getAllEntityFieldValues());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(StatistikLaufConstants.MESSAGE_KEY_ENTITY_EINZAHL, StatistikLaufConstants.MESSAGE_KEY_AUSLOESER_EINZAHL, ausloeser));
                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(StatistikLaufConstants.MESSAGE_KEY_ENTITY_EINZAHL, StatistikLaufConstants.MESSAGE_KEY_ZEITPUNKT_DES_LAUFS_EINZAHL, zeitpunktDesLaufs));
        
        return result;
      }


            @Override
            public String toString() {
            return "StatistikLaufTK[" + toStringParameter() + "]";
            }



            protected String toStringParameter() {
            String result = ""

                                        +"ausloeser="+ausloeser
                            +", zeitpunktDesLaufs="+zeitpunktDesLaufs
                                        +", wahlTK="+wahlTK
                            +", wahlterminTK="+wahlterminTK
            
            ;
                            return result;
            
            }
  
  @Override
  public String toStringLokalisiert(Messages messages) {
    return messages.getMessageForMessageKey(getEntityMessageKey()) + " ["
    + messages.getMessageForMessageKey(StatistikLaufConstants.MESSAGE_KEY_AUSLOESER_EINZAHL) + "=" + ausloeser
    + ", " + messages.getMessageForMessageKey(StatistikLaufConstants.MESSAGE_KEY_ZEITPUNKT_DES_LAUFS_EINZAHL) + "=" + zeitpunktDesLaufs
    + ", " +  toStringLokalisiert(wahlTK, messages)
    + ", " +  toStringLokalisiert(wahlterminTK, messages)
                + "]"

            ;
  }

            private String toStringLokalisiert(de.ivu.elect.jee.entity.tk.EntityTK entityTK, Messages messages) {
                if (entityTK != null) {
                    return entityTK.toStringLokalisiert(messages);
                }
                return null;
            }

            public static <E extends StatistikLauf> java.util.Map<StatistikLaufTK, E> mappeStatistikLaufNachTK(java.util.Collection<E> entities) {
                return entities.stream().collect(java.util.stream.Collectors.toMap(StatistikLauf::getStatistikLaufTK, Function.<E>identity(), (u,v)-> v));
                }


                public static Function<StatistikLauf, StatistikLaufTK> getStatistikLaufToTKFunction() {
                return StatistikLauf::getStatistikLaufTK;
                }

}
